
## How to create a userdefined class with some attributes and methods?
"""
# Creating Class
class Employee:
    # Creating Attributes
    eno = 101
    ename = "Sachin"

    # Creating Method
    def display(self):
        print('I am from display() method')
"""

## How to create a object for userdefined class and how to access attributes and methods?
"""
# Creating Class
class Employee:
    # Creating Attributes
    eno = 101
    ename = "Sachin"

    # Creating Method
    def display(self):
        print('I am from display() method')

    def message(self, name):
        print('Hello',name)

# Creating object
emp = Employee()

#Accessing attributes using object reference

print("Employee Number is :",emp.eno)
print("Employee Name is :", emp.ename)

#Accessing methods using object reference
emp.display()
emp.message() # TypeError: Employee.message() missing 1 required positional argument: 'name'
"""

# What is output?
"""
# Creating Class
class Employee:
    # Creating Attributes
    eno = 101
    ename = "Sachin"

    # Creating Method
    def display(self):
        print('I am from display() method')

    def message(self, name):
        print('Hello',name)

# Creating object
emp = Employee()

#Accessing attributes using object reference

print("Employee Number is :",emp.eno)
print("Employee Name is :", emp.ename)

#Accessing methods using object reference
emp.display()
emp.message("Shireen")
"""


## Accessing attributes using ClassName, object reference and self parameter
##  inside the className and inside methodName
"""
# Creating Class
class Employee:
    # Creating Attributes
    eno = 101
    ename = "Sachin"

    # Creating Method
    def display(self):
        print("Employee Number is :",Employee.eno)
        print("Employee Name is :", Employee.ename)
        print("Employee Number is :",emp.eno)
        print("Employee Name is :", emp.ename)
        print("Employee Number is :",self.eno)
        print("Employee Name is :", self.ename)
        
emp = Employee()
emp.display() 
"""

## Accessing attributes using ClassName, object reference and self Outside the className 
"""
# Creating Class
class Employee:
    # Creating Attributes
    eno = 101
    ename = "Sachin"

    # Creating Method
    def display(self):
        print("Employee Number is :",Employee.eno)
        print("Employee Name is :", Employee.ename)
        print("Employee Number is :",emp.eno)
        print("Employee Name is :", emp.ename)
        print("Employee Number is :",self.eno)
        print("Employee Name is :", self.ename)
        
emp = Employee()
emp.display() 
print()
print("Employee Number is :",Employee.eno)
print("Employee Name is :", Employee.ename)
print("Employee Number is :",emp.eno)
print("Employee Name is :", emp.ename)
print("Employee Number is :",self.eno) # NameError: name 'self' is not defined
print("Employee Name is :", self.ename)   
"""













