
###  Scope of Variables
'''
1. Global Variables ( Global Scope )
2. Local Variables  ( Local Scope )
3. Parameterized Variables ( Local Scope)
4. Class Variables|Static Varioables ( Class Scope )
5. Instance Variables | Non-Static Variables ( instance Scope)
'''

### Create a Global + Local + Parameterized variables and Access It
'''
a = 10 # Global Variable
class Employee:
    def display(self, c=30): # Paramerized Variable
        b = 20 # Local variable
        print("Inside Method : Value of a variable is :",a)
        print("Inside Method : Value of b variable is :", b)
        print("Inside Method : Value of c variable is :", c)

emp = Employee()
emp.display()
print()
print("Outside Method : Value of a variable is :",a)
#print("Outside Method : Value of b variable is :", b) # NameError: name 'b' is not defined
# print("Outside Method : Value of c variable is :", c) # NameError: name 'c' is not defined
'''


##
'''
a = 10 # Global Variable
class Employee:
    def display(self):
        a = 20 # Local variable
        print("Inside Method : Value of a variable is :",a) # 20

emp = Employee()
emp.display()
print()
print("Outside Method : Value of a variable is :",a) # 10
'''

##
'''
a = 10 # Global Variable
class Employee:
    def display(self):
        global a
        a = 20 # Local variable
        print("Inside Method : Value of a variable is :",a) # 20

emp = Employee()
emp.display()
print()
print("Outside Method : Value of a variable is :",a) # 20
'''

## Creating class Variable and Access it
'''
a = 10 # Global Variable
class Employee:
    d = 40 # class | static variable
    def display(self, c=30): # Paramerized Variable
        b = 20 # Local variable
        print("Inside Method : Value of Global variable a is :",a)
        print("Inside Method : Value of Local variable b is :", b)
        print("Inside Method : Value of Paramerized variable c  is :", c)
        print("Inside Method : Value of Class variable d is :", Employee.d)
        print("Inside Method : Value of Class variable d is :", emp.d)
        print("Inside Method : Value of Class variable d is :", self.d)

emp = Employee()
emp.display()
print()
print("Outside Method : Value of a variable is :",a)
#print("Outside Method : Value of b variable is :", b) # NameError: name 'b' is not defined
# print("Outside Method : Value of c variable is :", c) # NameError: name 'c' is not defined
print("Outside Method : Value of Class variable d is :", Employee.d)
print("Outside Method : Value of Class variable d is :", emp.d)
# print("Outside Method : Value of Class variable d is :", self.d) # NameError: name 'self' is not defined
'''

## Instance Variables
"""
a = 10 # Global Variable
class Employee:
    d = 40 # class | static variable

    def create(self):
        self.e = 50 # instance | non-static variable

    def display(self, c=30): # Paramerized Variable
        # self.e = 50 # instance | non-static variable
        b = 20 # Local variable
        print("Inside Method : Value of Global variable a is :",a)
        print("Inside Method : Value of Local variable b is :", b)
        print("Inside Method : Value of Paramerized variable c  is :", c)
        print("Inside Method : Value of Class variable d is :", Employee.d)
        print("Inside Method : Value of Class variable d is :", emp.d)
        print("Inside Method : Value of Class variable d is :", self.d)
        print("Inside Method : Value of Instance variable e is :", self.e)

emp = Employee()
emp.create()
emp.display()
print()
print("Outside Method : Value of a variable is :",a)
#print("Outside Method : Value of b variable is :", b) # NameError: name 'b' is not defined
# print("Outside Method : Value of c variable is :", c) # NameError: name 'c' is not defined
print("Outside Method : Value of Class variable d is :", Employee.d)
print("Outside Method : Value of Class variable d is :", emp.d)
# print("Outside Method : Value of Class variable d is :", self.d) # NameError: name 'self' is not defined
# print("Outside Method : Value of Instance variable e is :", self.e) # NameError: name 'self' is not defined
"""


###
'''
class Employee:
    company = "AshokIT Solutions"

    def create(self, eno, ename):
        self.eno = eno
        self.ename = ename

    def display(self):
        print("Company Name is :", Employee.company)
        print("Employee Number is :", self.eno)
        print("Employee Name is :", self.ename)

emp1 = Employee()
emp2 = Employee()

emp1.create(1, "Virat")
emp2.create(2, "Rohit")

emp1.display()
print()
emp2.display()
'''

## Creating class variable and Accessing Same value using all objects of the Class
'''
class Book:
    book_type = "Programming"

python_book = Book()
java_book = Book()
c_book = Book()

print(python_book.book_type)
print(java_book.book_type)
print(c_book.book_type)
'''


## Creating instance variable and Accessing Separate value using  each objects of the Class
'''
class Book:
    def __init__(self,booktype):
        self.booktype = booktype

python_book = Book("Python Programming")
java_book = Book("Java Programming")
c_book = Book("C Programming")

print(python_book.booktype)
print(java_book.booktype)
print(c_book.booktype)
'''











